﻿##### Scriptinfo ##################################################################################
# Scriptreihe:      ElasticAgent-installer
# Datum:            2024-11-20
# Version:          V1.00
# Programmierer:    Stephan Walther
###################################################################################################

# Variablen
    $PathAD = "\\ws.its\NETLOGON\ElasticAgent"
    $Logfile = @()

# Ermittle Aktion
    $action = "none"
    if (-not (Get-Service | Where-Object { $_.name -eq 'Elastic Agent' })) {
        $action = "installiere ElasticAgent"
        $param = "-i"
        $exit = 1
    }

# starte Aktion bei Bedarf
    New-EventLog -LogName "Application" -Source "ElasticAgentInstaller" -ErrorAction SilentlyContinue

    if ($action -ne 'none') {
        try {
            $Logfile += "Aktion: $action"
            $Logfile += "kopiere Dateien nach lokal"
            Copy-Item -Recurse -Path $PathAD -Destination 'c:\windows\temp\ElasticAgent' -ErrorAction Stop -Force

            $Logfile += "starte setup:C:\Windows\Temp\ElasticAgent\elastic-agent.exe -install --url=https://siem.ws.its:8220 --enrollment-token=xxxx=="
            Start-Process -FilePath 'C:\Windows\Temp\ElasticAgent\elastic-agent.exe' -ArgumentList 'install --force --url=https://siem.ws.its:8220 --enrollment-token=WEtdvaSUJGMXdv5U1JoVdvhnbEJGedv9wUnldvTvdhQQ==' -wait -ErrorAction Stop

            Start-Sleep -Seconds 5
            
            $Logfile += "entferne Arbeitsverzeichnis C:\windows\Temp\ElasticAgent"
            Remove-Item -Path 'C:\Windows\Temp\ElasticAgent' -Recurse

            $Logfile += "erfolgreich abgeschlossen"
            Write-EventLog -LogName "Application" -Source "ElasticAgentInstaller" -EntryType Information -EventId 2 -Message "$( $Logfile -join "`r`n" )"  
        }
        catch {
            $Logfile += "Fehler in Zeile $( $error[0].InvocationInfo.ScriptLineNumber ): $( $error[0].Exception.Message )"
            Write-EventLog -LogName "Application" -Source "ElasticAgentInstaller" -EntryType Error -EventId 3 -Message "$( $Logfile -join "`r`n" )"
        }
    } else {
        $Logfile += "keine Aktion erforderlich"
        Write-EventLog -LogName "Application" -Source "ElasticAgentInstaller" -EntryType Information -EventId 1 -Message "$( $Logfile -join "`r`n" )"
    }